/**
 ** Configuration file for NNTPlink.  Please edit the following
 ** apropriately.
 **/

/**
 ** Define the following if you are on a 4.2BSD system or later.
 **/
#define BSD4_2

/** 
 ** Define the following if you are on an USG system.
 **/
#ifndef BSD4_2
#define  USG
#endif

/**
 ** Number of articles we must have offered to remote end before
 ** nntplink decides to close and reopen the link at the next opportunity
 ** (so the other end gets a chance to log statistics).
 **/
#define CLOSE_AFTER	50

/**
 ** Number of articles we must have offered to remote end before
 ** nntplink decides to log local statistics.
 **/
#define LOG_AFTER	50

/**
 ** Define the following if you want the xferstats logged to a file.
 **/
#undef USELOG

/**
 ** Define DECNET if you want DECnet support.
 **/
#undef DECNET

/**
 ** Define EXCELAN if you are using an USG system with an EXCELAN ethernet
 **  board.
 **/
#undef EXCELAN

/**
 ** If we have 4.3BSD syslog, then what facility shoulw we log under?
 **/
#define LOG_LINK LOG_NEWS

/**
 ** Define this if you want nntplink to fork and go into the background
 **   automatically.  Do not define this if you are going to run nntplink
 **   from newsxd.
 **/
#undef AUTOBACKGROUND

/**
 ** Define this if the batch files often get corrupt on your system.  This will
 **   ensure that the batch file is ok before it starts processing it.  If you
 **   define this, then the batch files can only be :F: variety.
 **/
#undef VERIFYQFILE

/** 
 ** Define this if you are running nntplink under newsxd.  This will not
 **   wait for the baby to die and start a new one.  newsxd takes care of
 **   that.
 **
 ** This is basically a hack, so if the program fails, it will automatically
 **   be restarted.  This should not be necessary.
 **/
#define DONT_WATCH

/**
 ** How often should each nntplink check for a batch file?
 **/
#define SLEEP_INT 10

/**
 ** Where is the news spool dir, the news batch dir, and the news log file?
 **/
#define SPOOL_DIR "/usr/spool/news/"            /* NOTICE the / at the end! */
#define BATCH_DIR "/usr/spool/news/batched"
#define LOG_FILE  "/var/log/nntplink"

/**
 ** Define the following if your batch file is being created by
 ** Cnews.  I.E.  is the pathname and the msgid separated by 
 ** spaces instead of tabs?
 **
 ** BTW: nntplink will check and make sure you are right.
 **/
#undef CNEWS

               /**** END OF COFIGURATION SECTION *****/

/*
** Random stuff needed for nntplink
**
** This file also contains a lot of assumptions about what features
** are available on the local system - if something is not working
** to your liking, look them over carefully.
*/

/**
 ** How long should NNTPlink sleep between failed connection attemps?  This is
 **  the base value.  You normally shouldn't have to change this.
 **
 ** We have exponential backoff with a maximum nap time of 5 minutes.  
 **/
#define NAP_TIME 10


#define SIGRET int	/* Newfangled signal() returns void, old returns int */


typedef	SIGRET	(*ifunp)();	/* pointer to function that returns */
				/* whatever signal() returns */

#define	dprintf	if (Debug) fprintf

#define	TIMEOUT	3600		/* seconds to read timeout in sfgets */

#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif

/* in goodbye() wait (or not) for QUIT response */
#define	WAIT		TRUE
#define	DONT_WAIT	FALSE

/* in lockfd(), blocking, or non_blocking */
#define	BLOCK		FALSE
#define	DONT_BLOCK	TRUE

#ifndef FAIL
#define	FAIL		(-1)
#endif


/* DECNET support is only there if the DECNET compile-time option defined */
#define	T_IP_TCP	1	/* transport is IP/TCP */
#define	T_DECNET	2	/* transport is DECNET */
#define	T_FD		3	/* transport is a descriptor */

/* for syslog, if we compile it in */
#define	L_DEBUG		1
#define	L_INFO		2
#define	L_NOTICE	3
#define	L_WARNING	4

#if defined(DECNET) && !defined(BSD4_2)/* if we have DECNET, we're an Ultrix */
#define	BSD4_2
#undef	USG
#endif

#if defined(EXCELAN) && defined(USG)/* if we have EXCELAN, we're an Uglix */
#define	USG
#undef	BSD4_2
#endif

#ifdef	USG			/* USG pinheadedness */
#ifndef dgux
#define	index	strchr
#define	rindex	strrchr
#define	u_long	unsigned long
#define	u_short	unsigned short
#endif
#endif

#ifdef	BSD4_2			/* look at all these goodies we get! */
#define	FTRUNCATE
#define	SYSLOG
#define	RELSIG
#endif	BSD4_2

#ifdef apollo
#undef SYSLOG			/* Apollos don't have this by default */
#endif

#ifdef USG			/* Am I assuming something */
#define	F_OK		0	/* does file exist */
#define	X_OK		1	/* is it executable by caller */
#define	W_OK		2	/* writable by caller */
#define	R_OK		4	/* readable by caller */
#endif

#define MAXLOGLENGTH	1024
#define MAXSYSNAME	255
